Index: utils.c
===================================================================
RCS file: /usr/cvsroot/asterisk/utils.c,v
retrieving revision 1.61
diff -r1.61 utils.c
730a731
> 
731a733,778
> 
> 
> /*--- url_decode: Decode URL (overwrite the string)  ---*/
> void url_decode(char *s) 
> {
> 	char *o;
> 	unsigned int tmp;
> 
> 	for (o = s; *s; s++, o++) {
> 		if (*s == '%' && strlen(s) > 2 && sscanf(s + 1, "%2x", &tmp) == 1) {
> 			/* have '%', two chars and correct parsing */
> 			*o = tmp;
> 			s += 2;	/* Will be incremented once more when we break out */
> 		} else /* all other cases, just copy */
> 			*o = *s;
> 	}
> 	*o = '\0';
> }
> 
> /*--- url_encode: write encoded version of url into buf up to len bytes---*/
> int url_encode(char *url, char *buf, size_t len)
> {
>     char *p;
>     int x = 0;
>     const char urlunsafe[] = " \"#%&+:;<=>?@[\\]^`{|}";
>     const char hex[] = "0123456789ABCDEF";
> 
>     memset(buf, 0, len);
>     for( p = url ; *p ; p++) {
>         if (*p < ' ' || *p > '~' || strchr(urlunsafe, *p)) {
> 			if ((x + 3) > len) {
> 				break;
> 			}
>             buf[x++] = '%';
>             buf[x++] = hex[*p >> 4];
>             buf[x++] = hex[*p & 0x0f];
>         } else {
>             buf[x++] = *p;
>         }
> 		if (x == len) {
> 			break;
> 		}
>     }
> 	return x;
> }
> 
